using UnityEngine;
using System.Collections;

public class GameConstants : MonoBehaviour {
	public float MaxScreenX;
	public float MinScreenX;
	public float MaxScreenZ;
	public float MinScreenZ;
	public float MaxPlayerX;
	public float MinPlayerX;
	public float MaxPlayerZ;
	public float MinPlayerZ;

	public float MaxPlayerY;
	public float MinPlayerY;

	public float PlayerStartX;
	public float PlayerStartY;
	public float PlayerStartZ;
	
	public int GuiFontSize;
	public int ActLevel;
	public int MaxLevel;
	public int NrDeaths;
	
	public string GoalCubeName;
	
	// Use this for initialization
	void Awake () {
		// just offscreen, no longer visible
		//MaxScreenX = 38f;
		//MinScreenX = -38f;
		MaxScreenZ = 20f;
		MinScreenZ = -13f;
		
		// fully visible onscreen
		MaxPlayerX = ( (float)Screen.width / (float)Screen.height ) * 10;
		
		if (MaxPlayerX < 17){
			MaxPlayerX = MaxPlayerX + 1;
		}
		
		MinPlayerX = MaxPlayerX * -1f;
		
		MaxScreenX = MaxPlayerX + 5;
		MinScreenX = MinPlayerX - 5;
		
		MaxPlayerZ = 11f;
		MinPlayerZ = -9f;
		
		// how low/high can you go ?
		MaxPlayerY = 20f;
		MinPlayerY = -20f;
		
		// Starting positions for the player character
		PlayerStartX =  0f;
		PlayerStartY =  0f;
		PlayerStartZ = -5f;
		
		// ints
		GuiFontSize = 20;
		
		ActLevel = 0;
		MaxLevel = 10;

		NrDeaths = 0;
		// names
		
		GoalCubeName = "Goal";
	}
	
	// Update is called once per frame
	void Update () {
	
	}
}
