using UnityEngine;
using System.Collections;

public class GameRulesController : MonoBehaviour {
	public enum GameRuleState {
		                   GameRuleNotOn, 
		                   GameRuleOn,
		                   GameRulePaused,
	                       };
	
	public GameRuleState MyGameRuleState;

	public enum GameRulePhase {
		                   GameRulePhaseNothing, 
		                   GameRulePhaseDying,
		                   GameRulePhaseResetAfterDeath,
		                   GameRulePhasePlayLevelUp,
		                   GameRulePhaseKillOldLevel,
		                   GameRulePhaseResetAfterLevelUp
	                       };
	public GameRulePhase MyGameRulePhase;
	
	public bool IsActive;
	public bool HasFinished;
	public bool PlayerActive;
	
	public Transform LevelPrefab01;
	public Transform LevelPrefab02;
	public Transform LevelPrefab03;
	public Transform LevelPrefab04;
	public Transform LevelPrefab05;
	public Transform LevelPrefab06;
	public Transform LevelPrefab07;
	public Transform LevelPrefab08;
	public Transform LevelPrefab09;
	public Transform LevelPrefab10;
	
	public Transform LevelPrefab11;
	public Transform LevelPrefab12;
	public Transform LevelPrefab13;
	public Transform LevelPrefab14;
	public Transform LevelPrefab15;
	public Transform LevelPrefab16;
	public Transform LevelPrefab17;
	public Transform LevelPrefab18;
	public Transform LevelPrefab19;
	public Transform LevelPrefab20;
	
	public Transform LevelPrefab21;
	public Transform LevelPrefab22;
	public Transform LevelPrefab23;
	public Transform LevelPrefab24;
	public Transform LevelPrefab25;
	public Transform LevelPrefab26;
	public Transform LevelPrefab27;
	public Transform LevelPrefab28;
	public Transform LevelPrefab29;
	public Transform LevelPrefab30;
	
	public GUIStyle CustomGUIStyle;
	
    Rect GuiRect;
	const int GuiFontSize = 20;
	const int GuiRightSidePos = 25;

	bool MustInitialize;
	bool GoToNextLevel;
	float GameRulesStartTime;
	float GameRulesRunTime;
	public int GameRulesRunTimeInt;	
	int LastTimeUpdateInt;
	
	int EndTimeDeathScene;
	
	GameConstants MyGameConstants;
	
	public int HiScore;
	public int ActScore;
	
	// Use this for initialization
	void Awake () {
		IsActive = false;
		HasFinished = false;
		MyGameRuleState = GameRuleState.GameRuleNotOn;
		
		MyGameConstants = FindObjectOfType(typeof(GameConstants)) as GameConstants;
		HiScore = 0;
		GoToNextLevel = true;
	}
	
	// Update is called once per frame
	void Update () {
		if (IsActive){
			DoGameRules();
		}
	}
	
	void DoGameRules(){
		if (MustInitialize){
			DoInit();
		}
		
		if (IsActive){
			// keep the time ...
			GameRulesRunTime = Time.time - GameRulesStartTime;
			GameRulesRunTimeInt = (int) GameRulesRunTime;
			
			if (GameRulesRunTimeInt >= LastTimeUpdateInt){
//				if (ActGhostTimeInt > 0){
///					ActGhostTimeInt--;
//				}
				
				LastTimeUpdateInt = GameRulesRunTimeInt + 1;
				
			}

			if(MyGameRulePhase == GameRulePhase.GameRulePhaseDying){
				MyGameRulePhase = GameRulePhase.GameRulePhaseResetAfterDeath;
			}			
			
			if(MyGameRulePhase == GameRulePhase.GameRulePhaseResetAfterDeath){
				DoInitResetAfterDeath ();
			}			
			
			if (MyGameRulePhase == GameRulePhase.GameRulePhasePlayLevelUp){
				MyGameRulePhase = GameRulePhase.GameRulePhaseKillOldLevel;
				GoToNextLevel = true;
			}
			
			if (MyGameRulePhase == GameRulePhase.GameRulePhaseResetAfterLevelUp ){
				if (GoToNextLevel){
					DoInitResetAfterLevelUp();
					GoToNextLevel = false;
				}
			}
		}
		
	}
	
	void DoInit(){		
		MustInitialize = false;
		
		MyGameRuleState = GameRuleState.GameRuleOn;
		
		MyGameRulePhase = GameRulePhase.GameRulePhaseNothing;
		
		GameRulesStartTime = Time.time;
		GameRulesRunTime = Time.time - GameRulesStartTime;
		GameRulesRunTimeInt = (int) GameRulesRunTime;
		
		if (MyGameConstants.ActLevel == 0) {
			MyGameConstants.ActLevel = 1;
		}
	
		SpawnLevel();
		
		LastTimeUpdateInt = GameRulesRunTimeInt + 1;
		ActScore = 0;
		
		if (MyGameConstants.ActLevel == 0) {
			MyGameConstants.ActLevel = 1;
		}
	}
	
	void DoInitResetAfterLevelUp(){		
		if (MyGameConstants.ActLevel < MyGameConstants.MaxLevel){
			MyGameConstants.ActLevel++;
		}
		else{
			MyGameConstants.ActLevel = 1;
		}
		
		SpawnLevel();
		
		MyGameRulePhase = GameRulePhase.GameRulePhaseNothing;
		
		GameRulesStartTime = Time.time;
		GameRulesRunTime = Time.time - GameRulesStartTime;
		GameRulesRunTimeInt = (int) GameRulesRunTime;
		
		LastTimeUpdateInt = GameRulesRunTimeInt + 1;
	}
	
	void SpawnLevel(){
		if (MyGameConstants.ActLevel == 1) {
			Instantiate(LevelPrefab01 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 2) {
			Instantiate(LevelPrefab02 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 3) {
			Instantiate(LevelPrefab03 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 4) {
			Instantiate(LevelPrefab04 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 5) {
			Instantiate(LevelPrefab05 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 6) {
			Instantiate(LevelPrefab06 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 7) {
			Instantiate(LevelPrefab07 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 8) {
			Instantiate(LevelPrefab08 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 9) {
			Instantiate(LevelPrefab09 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 10) {
			Instantiate(LevelPrefab10 , this.transform.position, this.transform.rotation);
		}

		if (MyGameConstants.ActLevel == 11) {
			Instantiate(LevelPrefab11 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 12) {
			Instantiate(LevelPrefab12 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 13) {
			Instantiate(LevelPrefab13 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 14) {
			Instantiate(LevelPrefab14 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 15) {
			Instantiate(LevelPrefab15 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 16) {
			Instantiate(LevelPrefab16 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 17) {
			Instantiate(LevelPrefab17 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 18) {
			Instantiate(LevelPrefab18 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 19) {
			Instantiate(LevelPrefab19 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 20) {
			Instantiate(LevelPrefab20 , this.transform.position, this.transform.rotation);
		}
	
		if (MyGameConstants.ActLevel == 21) {
			Instantiate(LevelPrefab21 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 22) {
			Instantiate(LevelPrefab22 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 23) {
			Instantiate(LevelPrefab23 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 24) {
			Instantiate(LevelPrefab24 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 25) {
			Instantiate(LevelPrefab25 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 26) {
			Instantiate(LevelPrefab26 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 27) {
			Instantiate(LevelPrefab27 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 28) {
			Instantiate(LevelPrefab28 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 29) {
			Instantiate(LevelPrefab29 , this.transform.position, this.transform.rotation);
		}
		if (MyGameConstants.ActLevel == 30) {
			Instantiate(LevelPrefab30 , this.transform.position, this.transform.rotation);
		}
		
	}
	
	
	void DoInitResetAfterDeath(){	
		MyGameConstants.NrDeaths++;
		StopGameRules();
	}
		
	public void StartGameRules(){
		IsActive = true;
		HasFinished = false;
		MustInitialize = true;
		MyGameRuleState = GameRuleState.GameRuleNotOn;
	}

	public void StopGameRules(){
		IsActive = false;
		HasFinished = true;
		
		MyGameRuleState = GameRuleState.GameRuleNotOn;
		MyGameRulePhase = GameRulePhase.GameRulePhaseNothing;
	}

	public void ResetGameRules(){
		HasFinished = false;
	}
	
		// --- GUI-Stuff 	
	void OnGUI () {
		if (IsActive){
			DisplayActLevel();
		}
	}

	void DisplayActLevel(){
		GuiRect.width = 50;			
		GuiRect.height = 20;
		
		GuiRect.x = 20;
		GuiRect.y = 20;
		
		GUI.Label (GuiRect, "Level  : " + MyGameConstants.ActLevel.ToString() + " " , CustomGUIStyle);		

		GuiRect.width = 50;			
		GuiRect.height = 20;
		
		GuiRect.x = 20;
		GuiRect.y = 50;
		
		GUI.Label (GuiRect, "Deaths : " + MyGameConstants.NrDeaths.ToString() + " " , CustomGUIStyle);		
	}
}
