using UnityEngine;
using System.Collections;

public class IntroController : MonoBehaviour {
	public bool IsActive;
	public bool HasFinished;
	bool MustInitialize;
	
	float IntroRunningTime;
	float IntroStopTime;
	
	Transform MyCameraInstance;
	
	public Transform IntroCamera;
	
	GameRulesController MyGameRulesController;
	
	// Use this for initialization
	void Awake () {
		MyGameRulesController = FindObjectOfType(typeof(GameRulesController)) as GameRulesController;	

		IsActive = false;
		HasFinished = false;
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		if (MustInitialize){
			DoInit();
		}
		
		if (IsActive){
			PlayIntro();
		}	
	}
	
	void DoInit(){
		IntroRunningTime = 0f;
		IntroStopTime = Time.time + IntroRunningTime;
		
		//MyCameraInstance = Instantiate(IntroCamera, this.transform.position, this.transform.rotation) as Transform;
		
		MustInitialize = false;
	}
	
	void PlayIntro(){
		HasFinished = true;
	}
	
	public void StartIntro(){
		IsActive = true;
		HasFinished = false;
		MustInitialize = true;
	}
	
	public void StopIntro(){
		//Destroy (MyCameraInstance.gameObject);
		IsActive = false;
	}
}
