using UnityEngine;
using System.Collections;

public class CursorController : MonoBehaviour {

	public enum MoveAxes { MouseXAndY = 0, MouseX = 1, MouseY = 2 }
	public MoveAxes axes = MoveAxes.MouseXAndY;
	public float sensitivityX = 0.5F;
	public float sensitivityY = 0.5F;

	public float minimumX = -360F;
	public float maximumX = 360F;

	public float minimumY = -60F;
	public float maximumY = 60F;

	float MoveX = 0F;
	float MoveY = 0F;
	float LastMoveX = 0F;
	float LastMoveY = 0F;
	
	void Awake ()
	{
		LastMoveX = 0f;
		LastMoveY = 0f;
	}
	

	void Update ()
	{
		if (axes == MoveAxes.MouseXAndY)
		{
			MoveX += Input.GetAxis("Mouse X") * sensitivityY;
			MoveY += Input.GetAxis("Mouse Y") * sensitivityY;
			
			transform.Translate ( -(LastMoveX - MoveX), - (LastMoveY - MoveY), 0);

			LastMoveX = MoveX;
			LastMoveY = MoveY;
		}
		else if (axes == MoveAxes.MouseX)
		{
		}
		else
		{
		}
	}
	
	void Start ()
	{
		// Make the rigid body not change rotation
		if (rigidbody)
			rigidbody.freezeRotation = true;
	}
}