using UnityEngine;
using System.Collections;

public class FPCAdditional : MonoBehaviour {
	GameRulesController MyGameRulesController;
	GameConstants MyGameConstants;
	Vector3 TempPosition;
	Vector3 OldPosition;
	bool OldPositionTaken;
	bool HasTriggered;
	Color AmbientLightColor;

	// Use this for initialization
	void Awake () {
		MyGameConstants = FindObjectOfType(typeof(GameConstants)) as GameConstants;
		MyGameRulesController = FindObjectOfType(typeof(GameRulesController)) as GameRulesController;
		OldPositionTaken = false;
		HasTriggered = false;
		
		AmbientLightColor.r = 0f;
		AmbientLightColor.g = 0f;
		AmbientLightColor.b = 0f;
		AmbientLightColor.a = 1f;
		
		RenderSettings.ambientLight = AmbientLightColor;
	}

	// Update is called once per frame
	void Update () {
		TempPosition = transform.position;
		TempPosition.y = TempPosition.y + 0.6f;		
//		MyGameRulesController.GhostLookAtPoint = TempPosition;
		
		if (OldPositionTaken){
			TempPosition = transform.position - OldPosition;
		}
		
		OldPosition = transform.position;
		OldPositionTaken = true;
		
		if (this.transform.position.y < -40f ){
			MyGameRulesController.MyGameRulePhase = GameRulesController.GameRulePhase.GameRulePhaseDying;
		}
	}
	
	void FixedUpdate(){
		if (this.transform.position.y < 5.5f ){
			if (AmbientLightColor.r < 0.1f){
				AmbientLightColor.r = AmbientLightColor.r + 0.02f;
				AmbientLightColor.g = AmbientLightColor.r;
				AmbientLightColor.b = AmbientLightColor.r;
		
				RenderSettings.ambientLight = AmbientLightColor;
				
			}
		}
		
	}
	
	// on collision	
	void OnTriggerEnter(Collider TheCollider) {   
//		Debug.Log(TheCollider.gameObject.name);
		if (    TheCollider.gameObject.name == MyGameConstants.GoalCubeName 
			 && !HasTriggered){
			MyGameRulesController.MyGameRulePhase = GameRulesController.GameRulePhase.GameRulePhasePlayLevelUp;
			HasTriggered = true;
		}
	}
}
