using UnityEngine;
using System.Collections;

public class FlyingPerformer : MonoBehaviour {
	enum PlayerState {
		                   Alive,
						   Dying	
	                       };
	
	PlayerState MyPlayerState;
	
	const float FireRateFireball = 0.125f;
	float NextShootTime;
	Vector3 TempDirection;

	int ActDamage;
	
	// bullets
	public Transform FireballBullet;
	
	// explosions
	public Transform Exposion01;

	GameConstants MyGameConstants;
	GameRulesController MyGameRulesController;

	// Use this for initialization
	void Awake () {
		MyGameConstants = FindObjectOfType(typeof(GameConstants)) as GameConstants;
		MyGameRulesController = FindObjectOfType(typeof(GameRulesController)) as GameRulesController;

		NextShootTime = Time.time + FireRateFireball;	
		
		MyPlayerState = PlayerState.Alive;
	}
	
	// Update is called once per frame
	void Update () {
		// destroy if game not on
	//	if (MyGameRulesController.MyGameRuleState == GameRulesController.GameRuleState.GameRuleNotOn) {
	//		Destroy (gameObject);
	//	}
	
	}
	
	void FixedUpdate(){
		if (MyPlayerState == PlayerState.Dying ){
			MovePlayerDying ();
		}
	}
	
	public void MovePlayer (Vector3 directionVector){
		if (MyPlayerState == PlayerState.Alive){
			MovePlayerAlive (directionVector);
		}
	}
		
	void MovePlayerAlive (Vector3 directionVector){
		TempDirection = directionVector;
		
		transform.Translate(TempDirection);			
				
	}
	
	void MovePlayerDying (){
	}
	
	public void ShootGun(){
		//if (MyPlayerState == PlayerState.Alive){
			ShootFireball();
		//}
	}
	
	void ShootFireball(){
		if (Time.time > NextShootTime){
			Instantiate(FireballBullet, this.transform.position, this.transform.rotation);
			NextShootTime = Time.time + FireRateFireball;
		}

	}
	
	void DestroyPlayer(){
		Destroy(gameObject);
		MyGameRulesController.PlayerActive = false;		
	}
	
	// on collision, check if player bullet
	void OnTriggerEnter(Collider TheCollider) {   
	}

}
