using UnityEngine;
using System.Collections;

public class MovieController : MonoBehaviour {
	public Texture texture01;
	public Texture texture02;
	public Texture texture03;
	
	public bool RandomizeAnimation;
	public bool RandomizeTime;
		
	int AnimationCounter;
	public int AnimationMax;
	public float AnimationRate;
	float NextTimeAnimate;
	
	GameRulesController MyGameRulesController;


	// Use this for initialization
	void Awake () {
		AnimationCounter = 1;
		
		NextTimeAnimate = Time.time + AnimationRate;

		MyGameRulesController = FindObjectOfType(typeof(GameRulesController)) as GameRulesController;
	}
	
	// Update is called once per frame
	void Update () {
		if (    Time.time >= NextTimeAnimate
			// && MyGameRulesController.MyGameRuleState == GameRulesController.GameRuleState.GameRuleOn
			){
			if (AnimationCounter < AnimationMax){
				AnimationCounter++;
			}
			else{
				AnimationCounter = 1;
			}
			
			if (RandomizeAnimation == true){
				AnimationCounter = Random.Range (1, AnimationMax +1);
			}
			
			if (AnimationCounter == 1){
				renderer.material.mainTexture = texture01;	
			}

			if (AnimationCounter == 2){
				renderer.material.mainTexture = texture02;	
			}

			if (AnimationCounter == 3){
				renderer.material.mainTexture = texture03;	
			}
			
			NextTimeAnimate = Time.time + AnimationRate;
		}
	}
}
