using UnityEngine;
using System.Collections;

public class TitleController : MonoBehaviour {

	public bool IsActive;
	public bool HasFinished;
	
	public GUIStyle CustomGUIStyle;
	public GUIStyle BigCustomGUIStyle;
	
	public Transform TitleCamera;
	
	bool MustInitialize;

    Rect GuiRect;
	
	GameRulesController MyGameRulesController;
	
	// Use this for initialization
	void Awake () {
		MyGameRulesController = FindObjectOfType(typeof(GameRulesController)) as GameRulesController;	
	
		IsActive = false;
		HasFinished = false;
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		if (MustInitialize){
			DoInit();
		}
	}
	
	void DoInit(){
		Instantiate(TitleCamera, this.transform.position, this.transform.rotation);
		MustInitialize = false;
	}
	
	public void StartTitle(){
		IsActive = true;
		HasFinished = false;
		MustInitialize = true;
	}

	public void StopTitle(){
		IsActive = false;
	}

	// --- GUI-Stuff 	
	void OnGUI () {
		if (IsActive){
			DisplayTitle();
	//		DisplayHiScore();
		}
	
	}

	void DisplayTitle(){
		DisplayGUIText_Center( "MINIMALISM : FIND THE RED CUBE ",
		                       "by M.Schwartzenberg, 2013",
  			                   "Press [LMB] to START!" );
	}
	
	void DisplayGUIText_Center (string TextTop, string TextMiddle, string TextBottom){
		GuiRect.width = TextTop.Length * 11;			
		GuiRect.height = 20;
		
		GuiRect.x = (Screen.width  / 2 ) - TextTop.Length * 10 - 20;
		GuiRect.y = 75;

		GUI.Label (GuiRect, TextTop, BigCustomGUIStyle);		

		GuiRect.width = TextMiddle.Length * 11;			
		GuiRect.height = 35;
			
		GuiRect.x = (Screen.width  / 2 ) - TextMiddle.Length * 10 - 20;
		GuiRect.y = Screen.height - 150;

		GUI.Label (GuiRect, TextMiddle, BigCustomGUIStyle);		

		GuiRect.width = TextBottom.Length * 11;			
		GuiRect.height = 35;
			
		GuiRect.x = (Screen.width  / 2 ) - TextBottom.Length * 10 - 20;
		GuiRect.y = Screen.height - 100;

		GUI.Label (GuiRect, TextBottom, BigCustomGUIStyle);		
	}
	
	void DisplayHiScore(){
		GuiRect.width = 50;			
		GuiRect.height = 20;
		
		GuiRect.x = 20;
		GuiRect.y = 20;
		GUI.Label (GuiRect, "HISCORE: " + MyGameRulesController.HiScore.ToString() + " " , BigCustomGUIStyle);		
	}

}
